# Create an invoice schedule Creates an invoice schedule. ### Limitations This API operation has the following limitations: * You can create at most 50 invoice schedule items in one request. * You can associate at most 10 orders with an invoice schedule in one request. * You can associate at most 300 subscriptions with an invoice schedule in one request, including those contained in orders and separate subscriptions. Note: This operation is available only if you have the Billing Schedule feature enabled. Endpoint: POST /v1/invoice-schedules Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `accountKey` (string) The ID or number of the account associated with the invoice schedule. Example: "A00000007" - `additionalSubscriptionsToBill` (array) A list of the numbers of the subscriptions that need to be billed together with the invoice schedule. One invoice schedule can have at most 600 additional subscriptions. Example: ["S-00000001","S-00000002"] - `invoiceSeparately` (boolean) Whether the invoice items created from the invoice schedule appears on a separate invoice when Zuora generates invoices. - `notes` (string) Comments on the invoice schedule. Example: "2022 Billing Schedule" - `orders` (array) A list of the IDs or numbers of the orders associated with the invoice schedule. One invoice schedule can be associated with at most 10 orders. Example: ["O-00000007","O-00000008"] - `scheduleItems` (array) Container for invoice schedule items. One invoice schedule can have at most 50 invoice schedule items. Example: [{"amount":50000,"runDate":"2022-02-24","targetDateForAdditionalSubscriptions":"2022-02-24"},{"amount":14000,"runDate":"2022-10-17","targetDateForAdditionalSubscriptions":"2022-10-17"},{"amount":6200,"runDate":"2022-11-14","targetDateForAdditionalSubscriptions":"2022-11-14"}] - `scheduleItems.amount` (number) The amount of the invoice to be generated during the processing of the invoice schedule item. You can only specify either the amount field or percentage field in one request. - If you choose to specify the amount field in the request, null is returned as the value of the percentage field in the corresponding response. - If you choose to specify the percentage field in the request, the value of the amount field returned in the corresponding response is calculated based on the percentage of the total amount. - `scheduleItems.name` (string) The name of the invoice schedule item. - `scheduleItems.percentage` (number) The percentage of the total amount to be billed during the processing of the invoice schedule item. You can only specify either the amount field or percentage field in one request. - If you choose to specify the amount field in the request, null is returned as the value of the percentage field in the corresponding response. - If you choose to specify the percentage field in the request, the value of the amount field returned in the corresponding response is calculated based on the percentage of the total amount. - `scheduleItems.runDate` (string) The date in the tenant’s time zone when the invoice schedule item is planned to be processed to generate an invoice. When specifying run dates for invoice schedule items, consider that: - An invoice schedule item with a blank run date will not be executed. - You can only update the run date for an invoice schedule item in Pending status. - If the run date of an invoice schedule item is left empty, the dates of all subsequent invoice schedule items must also be blank. - You must specify run dates in chronological order for invoice schedule items. - `scheduleItems.targetDateForAdditionalSubscriptions` (string) The date in the tenant's time zone used by the invoice schedule to determine which fixed-period regular charges to be billed together with the invoice schedule item. The regular charges must come from the subscriptions specified in the additionalSubscriptionsToBill field. - `specificSubscriptions` (array) A list of the numbers of specific subscriptions associated with the invoice schedule. - If the subscriptions specified in this field belong to the orders specified in the orders field, only the specific subscriptions instead of the orders are associated with the invoice schedule. - If only the orders field is specified, all the subscriptions from the order are associated with the invoice schedule. Example: { "orders": [ "O-00000001", "O-00000002" ], "specificSubscriptions": [ { "orderKey": "O-00000001", "subscriptionKey": "S-00000001" } ] } - For the order with number O-00000001, only subscription S-00000001 contained in the order is associated with the invoice schedule. - For the order with number O-00000002, all subscriptions contained in the order are associated with the invoice schedule. Example: [{"orderKey":"O-00000008","subscriptionKey":"S-00000008"}] - `specificSubscriptions.chargeNumbers` (string) A list of charges in the subscription that are chosen to be included in the invoice schedule. - `specificSubscriptions.orderKey` (string) The unique ID or number of the order associated with the invoice schedule. - `specificSubscriptions.subscriptionKey` (string) The unique number of the subscription contained in the order associated with the invoice schedule. ## Response 200 fields (application/json): - `accountId` (string) The ID of the customer account that the invoice schedule belongs to. - `actualAmount` (number) The actual amount that needs to be billed during the processing of the invoice schedule. By default, the actual amount is the same as the total amount. Even if order changes occur like Remove Product or Cancel Subscription, the value of the totalAmount field keeps unchanged. The value of the actualAmount field reflects the actual amount to be billed. - `additionalSubscriptionsToBill` (array) A list of the numbers of the subscriptions that need to be billed together with the invoice schedule. One invoice schedule can have at most 600 additional subscriptions. - `billedAmount` (number) The amount that has been billed during the processing of the invoice schedule. - `currency` (string) The currency of the billing documents generated during the processing of the invoice schedule. Note: - This field is available only if you have the Multiple Currencies feature enabled. - If you have the Multiple Currencies feature disabled, the corresponding account's default currency is always used. - `id` (string) The unique ID of the invoice schedule. - `invoiceSeparately` (boolean) Whether the invoice items created from the invoice schedule appears on a separate invoice when Zuora generates invoices. - `nextRunDate` (string) The run date of the next execution of invoice schedule. By default, the next run date is the same as run date of next pending invoice schedule item. It can be overwritten with a different date other than the default value. When the invoice schedule has completed the execution, the next run date is null. - `notes` (string) Comments on the invoice schedule. - `number` (string) The sequence number of the invoice schedule. - `orders` (array) A list of the IDs or numbers of the orders associated with the invoice schedule. One invoice schedule can be associated with at most 10 orders. - `scheduleItems` (array) Container for schedule items. One invoice schedule can have at most 50 invoice schedule items. - `scheduleItems.actualAmount` (string) The actual amount that needs to be billed during the processing of the invoice schedule item. By default, the actual amount is the same as the total amount. Even if order changes occur like Remove Product or Cancel Subscription, the value of the amount field keeps unchanged. The value of the actualAmount field reflects the actual amount to be billed. - `scheduleItems.amount` (string) The amount of the invoice generated during the processing of the invoice schedule item. You can only specify either the amount field or percentage field in one request. - If you choose to specify the amount field in the request, null is returned as the value of the percentage field in the corresponding response. - If you choose to specify the percentage field in the request, the value of the amount field returned in the corresponding response is calculated based on the percentage of the total amount. The value of this field keeps unchanged once invoice schedule items are created. - `scheduleItems.creditMemoId` (string) The ID of the credit memo that is generated during the processing of the invoice schedule item. - `scheduleItems.id` (string) The unique ID of the invoice schedule item. - `scheduleItems.invoiceId` (string) The ID of the invoice that is generated during the processing of the invoice schedule item. - `scheduleItems.name` (string) The name of the invoice schedule item. - `scheduleItems.percentage` (any) The percentage of the total amount to be billed during the processing of the invoice schedule item. You can only specify either the amount field or percentage field in one request. - If you choose to specify the amount field in the request, null is returned as the value of the percentage field in the corresponding response. - If you choose to specify the percentage field in the request, the value of the amount field returned in the corresponding response is calculated based on the percentage of the total amount. - `scheduleItems.runDate` (string) The date in the tenant’s time zone when the invoice schedule item is processed to generate an invoice. - `scheduleItems.status` (string) The status of the invoice schedule item. Enum: "Pending", "Executing", "Processed" - `scheduleItems.targetDateForAdditionalSubscriptions` (string) The date in the tenant's time zone used by the invoice schedule to determine which fixed-period regular charges to be billed together with the invoice schedule item. The regular charges must come from the subscriptions specified in the additionalSubscriptionsToBill field. - `scheduleItems.organizationLabel` (string) Indicates the organization assigned to the Invoice Schedule Item for multi-org. - `specificSubscriptions` (array) A list of the numbers of specific subscriptions associated with the invoice schedule. - `specificSubscriptions.chargeNumbers` (string) A list of charges in the subscription that are chosen to be included in the invoice schedule. - `specificSubscriptions.orderKey` (string) The unique ID or number of the order associated with the invoice schedule. - `specificSubscriptions.subscriptionKey` (string) The unique number of the subscription contained in the order associated with the invoice schedule. - `status` (string) The status of the invoice schedule. Enum: "Pending", "PartiallyProcessed", "Paused", "FullyProcessed" - `totalAmount` (number) The total amount that needs to be billed during the processing of the invoice schedule. The value of this field keeps unchanged once invoice schedule items are created. - `unbilledAmount` (number) The amount that is waiting to be billed during the processing of the invoice schedule. - `organizationLabel` (string) Indicates the organization assigned to the Invoice Schedule for multi-org. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.